-- 皮肤道具tips
Lua_FashionItemDetailsWindow = class("Lua_FashionItemDetailsWindow", Lua_Window);
function Lua_FashionItemDetailsWindow:ctor()
	self:superCall("ctor");

	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.windowName = "Lua_FashionItemDetailsWindow";
	self.skinName = "FashionItemDetailsWindow_skin";

    self.showBlackMask = true;
    self.isClickClose = true;
end

function Lua_FashionItemDetailsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragContainer = Lua_DragContainer.new(self.content, 436, 326, Lua_AxisDefine.Vertical);
	self.dragContainer:setLocation(5, 0, 0);
	self.dragContainer:setRectPivot(1);

	self:showBtn(false);
	self.btnSp:addClickFuntion(self, self.onClickBtnSp);
end

function Lua_FashionItemDetailsWindow:onClickBtnSp(go)
	if self.showData ~= nil and self.showData.data ~= nil then
		DataCenter.packUtil:doActClick(self.showData.data, 1);
	end
end

function Lua_FashionItemDetailsWindow:showWin(param)
	self:superCall("showWin", param);

	local skinId = param and param.data and param.data.clothes_id or 0;
	if skinId <= 0 then
		return;
	end
	self:showBtn(param.isShowBtns);
	self.skinData = Lua_HeroFashionConfigData.getConfig(skinId);
	if self.skinData == nil then
		return;
	end

	self.skinNameTxt.text = self.skinData.name;
	DataCenter.sceneUtil:setSceneDataExtendVal(self.windowName, "FurEffShow", self.skinData.bShowFur);
	self:showSkinHero();

	self.dragContainer:clearList();
	local data = self.skinData.curProp;
	if data ~= nil then
		self.dragContainer:addSubContainer(Lua_FashionItemDetailsSingleHeroPropItem, data, false);
	end

	data = self.skinData.allProp;
	if data ~= nil then
		self.dragContainer:addSubContainer(Lua_FashionItemDetailsAllHeroPropItem, data, false);
	end

	if self.skinData.curProp ~= nil or self.skinData.allProp ~= nil then
		self.dragContainer:addSubContainer(Lua_FashionItemDetailsSplitItem, true, false);
	end

	self.dragContainer:addSubContainer(Lua_FashionItemDetailsDescItem, self.skinData, false);
	self.dragContainer:updateChildPos();

	self:updateHeight();
end

function Lua_FashionItemDetailsWindow:updateHeight()
	local item;
	local height = 0;
	local len = self.dragContainer.showList:getSize();
	for i = 1, len do
		item = self.dragContainer.showList:getItem(i);
		height = height + (item and item:getHeight() or 0);
	end

	height = height > 326 and 326 or height;
	self.dragContainer:setContentRect(436, height)

	local originHeight = self.showData.isShowBtns and 533 or 460;
	self.bg:SetDimensions(529, originHeight + height);
	LuaUtil.setObjPos(self.btnObj, 0, self.dragContainer.posY - height - 44, 0);
end

function Lua_FashionItemDetailsWindow:showBtn(bShow)
	self.btnObj:SetActive(bShow);
end

function Lua_FashionItemDetailsWindow:dispose()
	DataCenter.sceneUtil:setSceneDataExtendVal(self.windowName, "FurEffShow", false);
	if self.modelEffImg ~= nil then
		self.modelEffImg:dispose();
		self.modelEffImg = nil;
	end
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	self:superCall("dispose");
end

function Lua_FashionItemDetailsWindow:showSkinHero()
	if self.modelEffImg == nil then
		self.modelEffImg = UICreate.createModelEffImg(self.content, self.skinData.uiModelUrl, self.skinData.uiModelSrc, -1, 226, 400, 400);
		self.modelEffImg:setCamField(1.2, 1, 100, true);
		self.modelEffImg:setCamPos(0, 1, -30);
		self.modelEffImg:setModelEffDir(180);
		self.modelEffImg.canRot = true;
		self.modelEffImg:showLight(1.6);
	else
		self.modelEffImg:setUrl(self.skinData.uiModelUrl, self.skinData.uiModelSrc);
	end
end











--------------------------------------------------------------
Lua_FashionItemDetailsBasePropItem = class("Lua_FashionItemDetailsBasePropItem", Lua_DragContainerItem);
function Lua_FashionItemDetailsBasePropItem:ctor(p)
	self:superCall("ctor", p, "FashionItemDetailsBasePropItem_skin");
end

function Lua_FashionItemDetailsBasePropItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_FashionItemDetailsBasePropItem:dispose()
	if self.props ~= nil then
		local item;
		for i = 1, #self.props do
			item = self.props[i]
			if item ~= nil then
				item:dispose();
				item = nil;
			end
		end
		self.props = nil;
	end

	self:superCall("dispose");
end

function Lua_FashionItemDetailsBasePropItem:setData(data)
	if data == nil then
		return;
	end


	local arr = DataCenter.attributesUtil:getAttrArrByDic(data);
	self.listHeight = Mathf.Ceil(arr:getSize() / 2) * 36;
	self:showTabs(arr);
end

function Lua_FashionItemDetailsBasePropItem:showTabs(propsData)
	local colNum = 2;
	if self.props == nil then
		self.props = {};
	end

	local item;
	local startX = -121;
	local startY = -55;
	local posX, posY;
	local distanceX = 235;
	local distanceY = 36;
	local len = propsData and propsData:getSize() or 0;
	for i = 1, len do
		item = self.props[i];
		if item == nil then
			item = Lua_FashionItemAttributeSubItem.new(self.content);
			item:setRectAnchor(1);
			self.props[i] = item;
		end
		posX = startX + (i - 1) % colNum * distanceX;
		posY = startY - Mathf.Floor((i - 1) / colNum) * distanceY;
		item:setData(propsData[i]);
		item:setLocation(posX, posY);
		item:setEnable(true);
	end

	if len < #self.props then
		for i = len + 1, #self.props do
			item = self.props[i];
			if item ~= nil then
				item:setEnable(false);
			end
		end
	end
end

function Lua_FashionItemDetailsBasePropItem:getWidth()
	return 436;
end

function Lua_FashionItemDetailsBasePropItem:getHeight()
    return self.listHeight + 46;
end





--------------------属性item--------------------
Lua_FashionItemAttributeSubItem = class("Lua_FashionItemAttributeSubItem", Lua_ListCell);
function Lua_FashionItemAttributeSubItem:ctor(p)
	self:superCall("ctor", p, "FashionItemAttributeSubItem_skin");
end

function Lua_FashionItemAttributeSubItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_FashionItemAttributeSubItem:setData(data)
    if data == nil then
    	return;
    end

    self.attr_value.text = LanUtil.formateStr(777000, data.show_name, data.showValue);
    self.attr_icon:setAltas("common_altas_2", data.attr_icon_2);
end

function Lua_FashionItemAttributeSubItem:dispose()
    self:superCall("dispose");
end



--------------------本英雄加成--------------------
Lua_FashionItemDetailsSingleHeroPropItem = class("Lua_FashionItemDetailsSingleHeroPropItem", Lua_FashionItemDetailsBasePropItem);
function Lua_FashionItemDetailsSingleHeroPropItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_FashionItemDetailsSingleHeroPropItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_FashionItemDetailsSingleHeroPropItem:dispose()
	self:superCall("dispose");
end

function Lua_FashionItemDetailsSingleHeroPropItem:setData(data)
	self:superCall("setData", data);
	
	self.titleNameTxt:setLangValue(777001);
end




--------------------全体英雄加成--------------------
Lua_FashionItemDetailsAllHeroPropItem = class("Lua_FashionItemDetailsAllHeroPropItem", Lua_FashionItemDetailsBasePropItem);
function Lua_FashionItemDetailsAllHeroPropItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_FashionItemDetailsAllHeroPropItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_FashionItemDetailsAllHeroPropItem:dispose()
	self:superCall("dispose");
end

function Lua_FashionItemDetailsAllHeroPropItem:setData(data)
	self:superCall("setData", data);
	
	self.titleNameTxt:setLangValue(777002);
end







---------------------------分割-----------------------------------
Lua_FashionItemDetailsSplitItem = class("Lua_FashionItemDetailsSplitItem", Lua_DragContainerItem);
function Lua_FashionItemDetailsSplitItem:ctor(p)
	self:superCall("ctor", p, "FashionItemDetailsSplitItem_skin");
end

function Lua_FashionItemDetailsSplitItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_FashionItemDetailsSplitItem:dispose()
	self:superCall("dispose");
end

function Lua_FashionItemDetailsSplitItem:setData(data)
	if data == nil then
		return;
	end

end

function Lua_FashionItemDetailsSplitItem:getWidth()
	return 436;
end

function Lua_FashionItemDetailsSplitItem:getHeight()
    return 6;
end







--------------------------------------------------------------
Lua_FashionItemDetailsDescItem = class("Lua_FashionItemDetailsDescItem", Lua_DragContainerItem);
function Lua_FashionItemDetailsDescItem:ctor(p)
	self:superCall("ctor", p, "FashionItemDetailsDescItem_skin");
end

function Lua_FashionItemDetailsDescItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_FashionItemDetailsDescItem:dispose()
	if self.descSps ~= nil then
		local item;
		for i = 1, #self.descSps do
			item = self.descSps[i]
			if item ~= nil then
				item:dispose();
				item = nil;
			end
		end
		self.descSps = nil;
	end

	self:superCall("dispose");
end

function Lua_FashionItemDetailsDescItem:setData(data)
	if data == nil then
		return;
	end


	local info = data.skinTabs or {};
	self:showTabs(info);

	local str;
	local itemId = data.activateItem;
	if itemId then
		local tvo = Lua_ToolVo.createToolVo(itemId);
		str = tvo.des;
	end
	self.descTxt:setLocation(-211, -self.tabListHeight);
	self.descTxt.text = str;
	self.descTxt:resetSize();
	self.curHeight = self.tabListHeight + self.descTxt.preferredHeight;
end

function Lua_FashionItemDetailsDescItem:showTabs(tabsData)
	if self.descSps == nil then
		self.descSps = {};
	end

	local item;
	local startX = -175;
	local startY = -33;
	local posX, posY;
	local distanceX = 76;
	local distanceY = 36;
	local len = tabsData and #tabsData or 0;
	for i = 1, len do
		item = self.descSps[i];
		if item == nil then
			item = Lua_FashionItemAttributeTabItem.new(self.content);
			item:setRectAnchor(1);
			self.descSps[i] = item;
		end
		posX = startX + (i - 1) % 5 * distanceX;
		posY = startY - Mathf.Floor((i - 1) / 5) * distanceY;
		item:setData(tabsData[i]);
		item:setLocation(posX, posY);
		item:setEnable(true);
	end

	if len < #self.descSps then
		for i = len + 1, #self.descSps do
			item = self.descSps[i];
			if item ~= nil then
				item:setEnable(false);
			end
		end
	end

	self.tabListHeight = Mathf.Ceil(len / 5 ) * (33 + 5) + 20; -- 20:
end

function Lua_FashionItemDetailsDescItem:getWidth()
	return 436;
end

function Lua_FashionItemDetailsDescItem:getHeight()
    return self.curHeight;
end




--------------------标签item--------------------
Lua_FashionItemAttributeTabItem = class("Lua_FashionItemAttributeTabItem", Lua_ListCell);
function Lua_FashionItemAttributeTabItem:ctor(p)
	self:superCall("ctor", p, "FashionItemAttributeTabItem_skin");
end

function Lua_FashionItemAttributeTabItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_FashionItemAttributeTabItem:setData(data)
    if data == nil then
    	return;
    end

    self.bg:setAltas(data[1], data[2]);
    self.descTxt.text = data[3];
end

function Lua_FashionItemAttributeTabItem:dispose()
    self:superCall("dispose");
end