checkRequire("Lua_PackPanel");
Lua_PackChipPanel = class("Lua_PackChipPanel", Lua_PackPanel);
function Lua_PackChipPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_PackChipPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.btnLeft:clearListener();
	self.btnLeft:setStyle(1);
	self.btnLeft:setLangValue(309079); -- 一键合成
	self.btnLeft:addClickFuntion(self, self.onSynthesisClick);

	self.btnRight:clearListener();
	self.btnRight:setStyle(3);
	self.btnRight:setLangValue(309001); -- 分解
	self.btnRight:addClickFuntion(self, self.onDecoClick);

	self.itemList:setLocation(0, 22, 0);
	self.itemList:setContentRect(630, 820);
    self.itemList:setListCell(Lua_PackChipItem, 140, 175, 4);
    self.itemList:setCellSpacing(20, 0);
end

function Lua_PackChipPanel:initEvent()
	self:addLuaEvent("ADD_PACK_ITEMS", self, self.addItem);
	self:addLuaEvent("REMOVE_PACK_ITEMS", self, self.removeItem);

	self:addLuaEvent("STRANGEBEAST_UPDATE_INFO", self, self.updateChipData);
	self:addLuaEvent("UPDATE_TACTIC_INFO", self, self.updateChipData);
end

function Lua_PackChipPanel:setData(data)
	self.data = data;
	self:updateShowInfo();

	DataCenter.packData:packListSortByType(data.package, "chipSort", false);
	self.itemArr, self.itemDic = DataCenter.packData:getPackArrByPackType(data.package);
	self:updateListInfo(self.itemArr);
end

function Lua_PackChipPanel:updateShowInfo()

end

function Lua_PackChipPanel:addItem(msg)
	self:superCall("addItem", msg);
	self.syntheticResult = nil;
end

function Lua_PackChipPanel:removeItem(msg)
	self:superCall("removeItem", msg);
	self.syntheticResult = nil;
end

function Lua_PackChipPanel:updateChipData()
	self.syntheticResult = nil;
	self:updateListInfo(self.itemArr);
end

-- 一键合成
function Lua_PackChipPanel:onSynthesisClick(go)
	if self.syntheticResult == 1 then
		OperateAlert.showLangValue(309080);
		return;
	elseif self.syntheticResult == 2 then
		OperateAlert.showLangValue(309081);
		return;
	end

	if self.clickTime and getTime() - self.clickTime < 0.3 then
		return;
	end
	self.clickTime = getTime();

	-- 英雄碎片
	if self.itemArr == nil then
		return;
	end

	local bagLeftLen = DataCenter.heroData.bagLeftLen;
	local bHas = false;
	local arr = Array();
	local vo;
	local count;
	for i = 1, self.itemArr:getSize() do
		vo = DataCenter.packData:getItemVoByUnId(self.itemArr[i]);
		if vo.isHeroChip then
			count = Mathf.Floor(vo.count / vo.synthesisNum);
			if count > 0 then
				bHas = true;
				if bagLeftLen > 0 then
					if bagLeftLen >= count then
						bagLeftLen = bagLeftLen - count;
						arr:add({ id = vo.id, count = count });
					else
						count = bagLeftLen;
						bagLeftLen = bagLeftLen - count;
						arr:add({ id = vo.id, count = count });
					end
				else
					break;
				end
			end
		end
	end

	if not bHas then
		self.syntheticResult = 1;
		OperateAlert.showLangValue(309080);
		return;
	end

	if not DataCenter.heroData:isBagEnough(1) then
		self.syntheticResult = 2;
		OperateAlert.showLangValue(309081);
		return;
	end

	Lua_ProxyManager.getProxy("Lua_PackProxy"):sOneKeySynthetic(arr);
	arr:clear();
	arr = nil;
end




















Lua_PackChipItem = class("Lua_PackChipItem", Lua_ListCell);
function Lua_PackChipItem:ctor(p)
	self:superCall("ctor", p, "PackChipItem_skin");
end

function Lua_PackChipItem:buildShowItem()
	self:superCall("buildShowItem");
	
	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setSiblingIndex(1)
	self.itemIcon:setLocation(0, 10, 0);
end

function Lua_PackChipItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_PackChipItem:setData(data)
	self.data = data;
	if type(data) == "number" then
		if data == 0 then
			self.data = nil;
		else
			self.data = DataCenter.packData:getItemVoByUnId(data);
		end
	end

	self.itemIcon:setData(self.data);
	self.itemIcon:showNum(0);
	self.itemIcon:setDoubleIcon(nil);
	if self.data == nil then
		self.itemIcon:showRedPoint(false);
		self.bar:setEnable(false);
		self.countText:setEnable(false);
		self:showUseLogo(false);
	else
		self.itemIcon:showRedPoint(self.data.canSynthesis);
		local maxValue = self.data.chipLimitNum;
		local value = self.data.count;
		if maxValue > 0 then
			self.bar:setEnable(true);
			self.bar:setMaxValue(maxValue);
			self.bar:setValue(value);
			self.countText:setEnable(true);
			self.countText.text = LanUtil.formateStr(10044, tostring(value), tostring(maxValue));
		else
			self.bar:setEnable(false);
			self.countText:setEnable(true);
			self.countText.text = value;
		end
		self:showUseLogo(self.data.use_logo == 1);
	end
end

function Lua_PackChipItem:showUseLogo(value)
	if value then
		if self.useIcon == nil then
			self.useIcon = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_label_11", 48.5, 71, 0, 0);
		end
		self.useIcon:setEnable(true);
	else
		if self.useIcon then
			self.useIcon:setEnable(false);
		end
	end
end

function Lua_PackChipItem:onPressClick()
	if self.data == nil or self.data.id == nil then
		return;
	end
	DataCenter.packUtil:showItemInfo(self.data, true, true);
end

function Lua_PackChipItem:onMouseDownHandle()
	self.itemIcon:setScale(0.95, 0.95, 0.95);
end

function Lua_PackChipItem:onMouseUpHandle()
	self.itemIcon:setScale(1, 1, 1);
end